<?php
namespace Incoviba\Middleware;

use Error;
use Exception;
use Psr\Http\Message\ResponseFactoryInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\RequestHandlerInterface;
use Psr\Log\LoggerInterface;
use Incoviba\Common\Alias\View;

class Errors
{
    public function __construct(protected LoggerInterface $logger, protected ResponseFactoryInterface $responseFactory, protected View $view) {}
    public function __invoke(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        try {
            return $handler->handle($request);
        } catch (Exception $exception) {
            $this->logger->notice($exception);
        } catch (Error $error) {
            $this->logger->error($error);
        }
        $response = $this->responseFactory->createResponse(600, 'Internal Server Error');
        if (str_contains($request->getUri()->getPath(), '/api')) {
            return $response;
        }
        return $this->view->render($response, 'construccion');
    }
}
